# -*- coding: utf-8 -*-

# warning.py
# This file is part of Oqapy serie 3
#
# Author: Vincent Vande Vyvre <vincent.vandevyvre@oqapy.eu>
# Home: http://www.oqapy.eu
# Copyright: 2014-2017 Vincent Vande Vyvre
# Licence: GPL3
#
# Warning dialog box

from PyQt5.QtCore import Qt
from PyQt5.QtWidgets import (QDialog, QGridLayout, QVBoxLayout, QHBoxLayout,
                             QLabel, QPlainTextEdit, QSpacerItem, QPushButton,
                             QSizePolicy)

class Warning_(QDialog):
    def __init__(self, what, fld, message):
        super().__init__()
        self.setWindowTitle("Oqapy - Warning")
        self.resize(400, 206)
        self.setSizeGripEnabled(True)
        self.gridLayout = QGridLayout(self)
        self.verticalLayout = QVBoxLayout()
        self.title_lbl = QLabel(self)
        self.title_lbl.setText(what)
        self.verticalLayout.addWidget(self.title_lbl)
        self.fld_lbl = QLabel(self)
        self.fld_lbl.setText(fld)
        self.verticalLayout.addWidget(self.fld_lbl)
        self.reason_lbl = QLabel(self)
        self.reason_lbl.setText("reason:")
        self.verticalLayout.addWidget(self.reason_lbl)
        self.error_ted = QPlainTextEdit(self)
        self.error_ted.setReadOnly(True)
        self.error_ted.setPlainText(message)
        self.verticalLayout.addWidget(self.error_ted)
        self.horizontalLayout = QHBoxLayout()
        spacer = QSpacerItem(40, 20, QSizePolicy.Expanding, QSizePolicy.Minimum)
        self.horizontalLayout.addItem(spacer)
        self.ok_btn = QPushButton("OK", self)
        self.horizontalLayout.addWidget(self.ok_btn)
        self.verticalLayout.addLayout(self.horizontalLayout)
        self.gridLayout.addLayout(self.verticalLayout, 0, 0, 1, 1)
        self.ok_btn.clicked.connect(self.accept)
