import os
import sipconfig

import sip
print(sip, sip.SIP_VERSION_STR)

# The name of the SIP build file generated by SIP and used by the build
# system.
build_file = "oqapy_iproc.sbf"

# Get the SIP configuration information.
config = sipconfig.Configuration()

# Run SIP to generate the code.
os.system(" ".join([config.sip_bin, "-c", ".", "-b", build_file, "oqapy_iproc.sip"]))

# Create the Makefile.
makefile = sipconfig.SIPModuleMakefile(config, build_file)

makefile.extra_lib_dirs=["/usr/lib", "/usr/lib/x86_64-linux-gnu/"]

# Add the library we are wrapping.  The name doesn't include any platform
# specific prefixes or extensions (e.g. the "lib" prefix on UNIX, or the
# ".dll" extension on Windows).
makefile.extra_libs = ["opencv_core", "opencv_highgui", "opencv_imgproc", 
                        "opencv_legacy", "opencv_contrib", "opencv_features2d", 
                        "opencv_ml", "opencv_gpu", "oqapy-iproc"]

# Generate the Makefile itself.
makefile.generate()
