# -*- coding: utf-8 -*-

# iptcpage.py
# This file is part of Oqapy serie 3
#
# Author: Vincent Vande Vyvre <vincent.vandevyvre@oqapy.eu>
# Home: http://www.oqapy.eu
# Copyright: 2015-2016 Vincent Vande Vyvre
# Licence: GPL3
#
# IPTC page widget

from PyQt5.QtCore import Qt, QSize, QRect
from PyQt5.QtWidgets import (QWidget, QGridLayout, QVBoxLayout, QHBoxLayout,
                             QLabel, QTabWidget, QScrollArea, QSizePolicy,
                             QSpacerItem, QCheckBox, QPlainTextEdit,
                             QLineEdit)


class IPTCPage(QWidget):
    def __init__(self, ui, parent=None):
        super().__init__(parent)
        self.ui = ui
        self.gridLayout_4 = QGridLayout(self)
        self.gridLayout_4.setContentsMargins(0, 0, 0, 0)
        self.verticalLayout_10 = QVBoxLayout()
        self.tabWidget = QTabWidget(self)
        alignment = Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter
        self.context_tab = QWidget()
        self.verticalLayout_7 = QVBoxLayout(self.context_tab)
        self.verticalLayout_7.setContentsMargins(0, 2, 2, 2)
        self.scrollArea_2 = QScrollArea(self.context_tab)
        self.scrollArea_2.setWidgetResizable(True)
        self.scrollwidget_2 = QWidget()
        self.scrollwidget_2.setGeometry(QRect(0, 0, 402, 369))
        self.verticalLayout_5 = QVBoxLayout(self.scrollwidget_2)
        self.verticalLayout_5.setContentsMargins(0, 0, 0, 0)
        self.verticalLayout_4 = QVBoxLayout()
        self.horizontalLayout_2 = QHBoxLayout()
        spacer2 = QSpacerItem(20, 20, QSizePolicy.Fixed, QSizePolicy.Minimum)
        self.horizontalLayout_2.addItem(spacer2)
        self.gridLayout_2 = QGridLayout()
        self.headline_lbl = QLabel(self.scrollwidget_2)
        self.headline_lbl.setAlignment(alignment)
        self.gridLayout_2.addWidget(self.headline_lbl, 0, 0, 1, 1)
        self.headline_led = QLineEdit(self.scrollwidget_2)
        self.headline_led.setMinimumSize(QSize(250, 0))
        self.gridLayout_2.addWidget(self.headline_led, 0, 1, 1, 1)
        self.verticalLayout_3 = QVBoxLayout()
        self.description_lbl = QLabel(self.scrollwidget_2)
        self.description_lbl.setAlignment(alignment)
        self.verticalLayout_3.addWidget(self.description_lbl)
        spacer3 = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout_3.addItem(spacer3)
        self.gridLayout_2.addLayout(self.verticalLayout_3, 1, 0, 1, 1)
        self.desc_ted = QPlainTextEdit(self.scrollwidget_2)
        self.gridLayout_2.addWidget(self.desc_ted, 1, 1, 1, 1)
        self.writer_lbl = QLabel(self.scrollwidget_2)
        self.writer_lbl.setAlignment(alignment)
        self.gridLayout_2.addWidget(self.writer_lbl, 3, 0, 1, 1)
        self.writer_led = QLineEdit(self.scrollwidget_2)
        self.writer_led.setMinimumSize(QSize(250, 0))
        self.gridLayout_2.addWidget(self.writer_led, 3, 1, 1, 1)
        self.verticalLayout_11 = QVBoxLayout()
        self.keywords_lbl = QLabel(self.scrollwidget_2)
        self.keywords_lbl.setAlignment(alignment)
        self.verticalLayout_11.addWidget(self.keywords_lbl)
        spacer10 = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout_11.addItem(spacer10)
        self.gridLayout_2.addLayout(self.verticalLayout_11, 4, 0, 1, 1)
        self.keywords_ted = QPlainTextEdit(self.scrollwidget_2)
        self.gridLayout_2.addWidget(self.keywords_ted, 4, 1, 1, 1)
        self.horizontalLayout_2.addLayout(self.gridLayout_2)
        self.verticalLayout_4.addLayout(self.horizontalLayout_2)
        spacer4 = QSpacerItem(17, 13, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout_4.addItem(spacer4)
        self.verticalLayout_5.addLayout(self.verticalLayout_4)
        self.scrollArea_2.setWidget(self.scrollwidget_2)
        self.verticalLayout_7.addWidget(self.scrollArea_2)
        self.tabWidget.addTab(self.context_tab, "")
        self.scene_tab = QWidget()
        self.verticalLayout_9 = QVBoxLayout(self.scene_tab)
        self.verticalLayout_9.setContentsMargins(0, 2, 2, 2)
        self.verticalLayout_8 = QVBoxLayout()
        self.horizontalLayout_3 = QHBoxLayout()
        spacer5 = QSpacerItem(20, 20, QSizePolicy.Fixed, QSizePolicy.Minimum)
        self.horizontalLayout_3.addItem(spacer5)
        self.gridLayout_3 = QGridLayout()
        self.place_lbl = QLabel(self.scene_tab)
        self.place_lbl.setAlignment(alignment)
        self.gridLayout_3.addWidget(self.place_lbl, 0, 0, 1, 1)
        self.place_led = QLineEdit(self.scene_tab)
        self.gridLayout_3.addWidget(self.place_led, 0, 1, 1, 1)
        self.city_lbl = QLabel(self.scene_tab)
        self.city_lbl.setAlignment(alignment)
        self.gridLayout_3.addWidget(self.city_lbl, 1, 0, 1, 1)
        self.city_led = QLineEdit(self.scene_tab)
        self.gridLayout_3.addWidget(self.city_led, 1, 1, 1, 1)
        self.state_lbl = QLabel(self.scene_tab)
        self.state_lbl.setAlignment(alignment)
        self.gridLayout_3.addWidget(self.state_lbl, 2, 0, 1, 1)
        self.state_led = QLineEdit(self.scene_tab)
        self.gridLayout_3.addWidget(self.state_led, 2, 1, 1, 1)
        self.country_lbl = QLabel(self.scene_tab)
        self.country_lbl.setAlignment(alignment)
        self.gridLayout_3.addWidget(self.country_lbl, 3, 0, 1, 1)
        self.country_led = QLineEdit(self.scene_tab)
        self.gridLayout_3.addWidget(self.country_led, 3, 1, 1, 1)
        self.horizontalLayout_3.addLayout(self.gridLayout_3)
        self.verticalLayout_8.addLayout(self.horizontalLayout_3)
        spacer6 = QSpacerItem(20, 40, QSizePolicy.Minimum, QSizePolicy.Expanding)
        self.verticalLayout_8.addItem(spacer6)
        self.verticalLayout_9.addLayout(self.verticalLayout_8)
        self.tabWidget.addTab(self.scene_tab, "")
        self.verticalLayout_10.addWidget(self.tabWidget)
        self.horizontalLayout_4 = QHBoxLayout()
        self.desc_chb = QCheckBox(self)
        self.desc_chb.setChecked(True)
        self.horizontalLayout_4.addWidget(self.desc_chb)
        spacer7 = QSpacerItem(498, 20, QSizePolicy.Expanding, QSizePolicy.Minimum)
        self.horizontalLayout_4.addItem(spacer7)
        self.verticalLayout_10.addLayout(self.horizontalLayout_4)
        self.description_ted = QPlainTextEdit(self)
        self.description_ted.setMaximumSize(QSize(16777215, 80))
        self.description_ted.setReadOnly(True)
        self.verticalLayout_10.addWidget(self.description_ted)
        self.gridLayout_4.addLayout(self.verticalLayout_10, 0, 0, 1, 1)

        self.retranslateUi()
        self.tabWidget.setCurrentIndex(0)

    def connect_signals(self):
        self.headline_led.focusInEvent = self.set_headline_desc
        self.headline_led.editingFinished.connect(self.on_headline_edited)
        self.desc_ted.focusInEvent = self.set_description_desc
        self.desc_ted.focusOutEvent = self.on_description_edited
        #self.desc_ted.textChanged.connect(self.on_description_edited)
        self.writer_led.focusInEvent = self.set_writer_desc
        self.writer_led.editingFinished.connect(self.on_writer_edited)
        self.keywords_ted.focusInEvent = self.set_keywords_desc
        self.keywords_ted.focusOutEvent = self.on_keywords_edited
        #self.keywords_ted.textChanged.connect(self.on_keywords_edited)
        self.place_led.focusInEvent = self.set_place_desc
        self.place_led.editingFinished.connect(self.on_place_edited)
        self.city_led.focusInEvent = self.set_city_desc
        self.city_led.editingFinished.connect(self.on_city_edited)
        self.state_led.focusInEvent = self.set_state_desc
        self.state_led.editingFinished.connect(self.on_state_edited)
        self.country_led.focusInEvent = self.set_country_desc
        self.country_led.editingFinished.connect(self.on_country_edited)
        self.desc_chb.stateChanged.connect(self.display_description)

    def on_headline_edited(self):
        txt = str(self.headline_led.text())
        self.ui.main.update_data('iptc', 'headline', txt)

    def on_description_edited(self, event):
        txt = self.desc_ted.toPlainText()
        self.ui.main.update_data('iptc', 'desc', txt)
        QPlainTextEdit.focusOutEvent(self.desc_ted, event)

    def on_writer_edited(self):
        txt = str(self.writer_led.text())
        self.ui.main.update_data('iptc', 'writer', txt)

    def on_keywords_edited(self, event):
        txt = self.keywords_ted.toPlainText()
        self.ui.main.update_data('iptc', 'kwords', txt)
        QPlainTextEdit.focusOutEvent(self.keywords_ted, event)

    def on_place_edited(self):
        txt = str(self.place_led.text())
        self.ui.main.update_data('iptc', 'place', txt)

    def on_city_edited(self):
        txt = str(self.city_led.text())
        self.ui.main.update_data('iptc', 'city', txt)

    def on_state_edited(self):
        txt = str(self.state_led.text())
        self.ui.main.update_data('iptc', 'state', txt)

    def on_country_edited(self):
        txt = str(self.country_led.text())
        self.ui.main.update_data('iptc', 'country', txt)

    def set_headline_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'headline')
        self.show_description(desc)
        QLineEdit.focusInEvent(self.headline_led, event)

    def set_description_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'desc')
        self.show_description(desc)
        QPlainTextEdit.focusInEvent(self.desc_ted, event)

    def set_writer_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'writer')
        self.show_description(desc)
        QLineEdit.focusInEvent(self.writer_led, event)

    def set_keywords_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'kwords')
        self.show_description(desc)
        QPlainTextEdit.focusInEvent(self.keywords_ted, event)

    def set_place_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'place')
        self.show_description(desc)
        QLineEdit.focusInEvent(self.place_led, event)

    def set_city_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'city')
        self.show_description(desc)
        QLineEdit.focusInEvent(self.city_led, event)

    def set_state_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'state')
        self.show_description(desc)
        QLineEdit.focusInEvent(self.state_led, event)

    def set_country_desc(self, event):
        desc = self.ui.main.get_tag_description('iptc', 'country')
        self.show_description(desc)
        QLineEdit.focusInEvent(self.country_led, event)

    def show_description(self, desc):
        self.description_ted.clear()
        self.description_ted.appendPlainText(desc)

    def display_description(self, state):
        self.description_ted.setVisible(state)

    def retranslateUi(self):
        self.headline_lbl.setText(_("Headline:"))
        self.description_lbl.setText(_("Description:"))
        self.writer_lbl.setText(_("Description writer:"))
        self.keywords_lbl.setText(_("Keywords:"))
        self.tabWidget.setTabText(0, _("IPTC - Context"))
        self.place_lbl.setText(_("Place:"))
        self.city_lbl.setText(_("City:"))
        self.state_lbl.setText(_("State - Province:"))
        self.country_lbl.setText(_("Country:"))
        self.tabWidget.setTabText(1, _("IPTC - Scene"))
        self.desc_chb.setText(_("Show description"))

